/*  PHONET CGI program example */
/* Sends Last-Modified field and inspects If-Modified-Since         */
PhoneFile = 'PHONE DATA'          /* File of telephone number data  */
DataDir   = 'SFSTEST:VMWEBCD.WEBSHARE.DATA' /* data file location   */
 
/*------------------------------------------------------------------*
 * Before we do any processing, see if we can skip all
 * of it because the browser has a good cached copy.
 *------------------------------------------------------------------*/
/* WEBSHARE/EWEB don't create variables for all header fields, so   */
/* create "extension variables" of X_HTTP_name                      */
'callpipe *.input.1:',            /* Get header records             */
       '| xlate w1 upper - _',    /* Make proper variable names     */
       '| spec fs : f1 1 f2-* strip 21',  /* Expand for JOIN        */
       '| sort 1-20',
       '| join keylength 20 /, /',        /* Combine matching hdrs  */
       '| spec /=X_HTTP_/ 1 w1 next /=/ next 21-* next', /* Vars    */
       '| varload'
If symbol('X_HTTP_IF_MODIFIED_SINCE') = 'VAR' then
   Call Check_Modified PhoneFile DataDir, x_http_if_modified_since
 
Parse arg query_string .
parm.=''                          /* Initialize default values      */
from_isindex = (pos('=',query_string) = 0)
Select
  When query_string = '' then nop /* Nothing to process             */
  When from_isindex Then
    'callpipe var query_string',
           '| xlate from 1047 to 819',  /* EBCDIC to ASCII          */
           '| urldeblock',
           '| xlate from 819 to 1047',  /* ..and back               */
           '| var isindex'
  Otherwise
    /* Webshare will make query string data available on stream 0   */
    'callpipe *:',
           '| xlate 1-* 05 40',   /* In case of any tab chars       */
           '| strip',             /* Ignore any empty ones          */
           '| locate 1',
           '| xlate fieldsep = f1 upper',  /* Upper case field name */
           '| specs "=PARM.?" 1 1-* next', /* Put it in varload fmt */
           '| varload'
End
 
Search=''                         /* Which entries to show.         */
SearchHTML=''                     /* Any additional text to show.   */
Select
  When query_string = '' then nop /* Nothing to search for          */
  When from_isindex Then do
    Search='| locate anycase 1-*  "'isindex'"'
    SearchHTML='<P>The results of your search request are shown.</P>'
  End
  When parm.?location <> '' Then do
    SearchArg = translate(left(parm.?location,3)) /* Search string  */
    Search='| locate 42-44 "'SearchArg'"'
    SearchHTML='<P>Only telephone numbers in location' SearchArg,
               'are shown.</P>'
  End
  Otherwise
End
 
'output HTTP/1.0 200 OK'          /* Response and header fields     */
'output Content-Type: text/html'
 
/*------------------------------------------------------------------*
 * Get the date stamp on our PHONE file and send it in
 * the correct HTTP format as the last modified date.
 *------------------------------------------------------------------*/
Parse value GetISOdate(PhoneFile DataDir) with RC filedate
If RC=0 then
   Parse value ISOHTTP(filedate) with RC httpdate
If RC=0
   then 'output Last-Modified:' httpdate
   else say 'Error - RC='rc 'from ISOHTTP('filedate')'
 
'output'
'callpipe < PROLOG1 HTMLPART | *:'/* Display the beginning HTML     */
 
If SearchHTML <> '' then          /* Extra message to display?      */
   'output' SearchHTML
 
'callpipe <sfs' PhoneFile DataDir,
       '| nlocate 1-1 "*"',       /* Ignore "comments" in col. 1    */
          Search,                 /* Maybe search for a location    */
       '| stem phone.'            /* Save result                    */
 
'output <TABLE BORDER="1">'       /* Set up the HTML table          */
'output <TH>Employee Number</TH>' /* Put a title on each column     */
'output <TH>Name</TH>'
'output <TH>Phone Number</TH>'
'output <TH>Location</TH>'
'output <TH>Office</TH>'
'output <TH>Status</TH>'
 
Do i=1 to phone.0                 /* Format the file for display    */
   'output <TR>'                  /* Beginning of a table row       */
   'output <TD>' substr(phone.i, 1, 6) '</TD>'  /* Each             */
   'output <TD>' substr(phone.i, 8,20) '</TD>'  /*   table          */
   'output <TD>' substr(phone.i,29,12) '</TD>'  /*      cell        */
   'output <TD>' substr(phone.i,42, 3) '</TD>'
   'output <TD>' substr(phone.i,46, 9) '</TD>'
   'output <TD>' substr(phone.i,56, 5) '</TD>'
   'output </TR>'                 /* End of a table row             */
End
'output </TABLE>'
'output <P><A HREF="../update.html">Update your telephone entry</A></P>'
'callpipe < FOOTER HTMLPART | *:' /* The ending HTML                */
Exit RC
 
Check_Modified:
/*------------------------------------------------------------------*
 * Convert the date from the If-Modified-Since field to ISODATE
 * format and compare with the date stamp on the file.
 * If they match, this routine never returns
 *------------------------------------------------------------------*/
Parse arg file, client_date
Parse value GetISOdate(file) with RC filedate
If RC <> 0 then Return
Parse value 'HTTPISO'(client_date) with RC cachedate
If RC <> 0 then Return
If filedate == cachedate then do
   /* They match!  Just write our status and exit */
   'output HTTP/1.0 304 Not Modified'
   'output'
   Exit
End
Return
 
GetISOdate: procedure
/* Use PIPE STATE to get a date/time stamp on a file. */
Parse arg file
'callpipe var file',
       '| state isodate',         /* Get the date of the data file  */
       '| spec 57-75 1',          /* (in ISODATE format.)           */
       '| var filedate'
Return RC filedate
