/* REXX --------------------------------------------------------------*/
/* VM/ESA Version 2                                                   */
/* Licensed Materials - Property of IBM Corp.                         */
/* (c) Copyright IBM Corp. 1996, 1998                                 */
/* All rights reserved.                                               */
/* US Government Users Restricted Rights -                            */
/* Use, duplication or disclosure restricted by                       */
/* GSA ADP Schedule Contract with IBM Corp.                           */
/* Sample CGI REXX code to process a WWW form                         */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*                                                                    */
/* Sample CGI to serve the available VM Web Server.                   */
/*                                                                    */
/* Currently supported interfaces:                                    */
/*                                                                    */
/* VM/ESA:                                                            */
/*                                                                    */
/* Webshare      (Richard M. Troth - freeware)                        */
/* EnterpriseWeb (Beyond Software Incorporated)                       */
/* VM:Webgateway  (Sterling Software)                                 */
/* VM:Webgateway in Webshare compatibility mode                       */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*                                                                    */
/* To write a CGI you only need to call the following sequence:       */
/*                                                                    */
/* call Init                                                          */
/* call Read                                                          */
/*                                                                    */
/* Thereafter, the variable stem post. contains all data posted to    */
/* the request (for example all data posted from a form).             */
/* See the comments in the Read routine for the format.               */
/* The variable query_string will contain the query_string (if        */
/* defined) from the url that referenced this cgi program             */
/*                                                                    */
/* For any line you wish to return to the client just call:           */
/*                                                                    */
/* call write 'STRING' 'whatever you like'                            */
/* call write 'STRING' 'It is now' time()                             */
/*                                                                    */
/* It is also possible to write a single variable or a complete       */
/* variable stem:                                                     */
/*                                                                    */
/* call write 'VAR varname'                                           */
/* or                                                                 */
/* call write 'STEM stemname.'                                        */
/*                                                                    */
/* You can also write server directivies:                             */
/*                                                                    */
/* call header 'STRING' 'Status: 200 OK'                              */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*--------------------------------------------------------------------*/
/*                                                                    */
/* The following variables are available for                          */
/* Webshare                                                           */
/*                                                                    */
/* path: /htbin/test?test=yes                                         */
/*                                                                    */
/* the following variables are set in this universal cgi:             */
/* ( the '.' in HTTP_ACCEPT=*.*; should be translated to '/',         */
/*   but is treated as 'end of comment' here)                         */
/*                                                                    */
/* ARG=test=yes                                                       */
/* ARGS=test=yes                                                      */
/* CGIUSERS=TROTH TWOOLBRI JFORD CWHITE BHUNTER MAINT VETTER D1MATTW  */
/* CLIENT=@9.12.14.94                                                 */
/* CONTENT_LENGTH=0                                                   */
/* FILE=/htbin/test                                                   */
/* FILEPOOLS=VMSYSER                                                  */
/* GATEWAY_INTERFACE=CGI/1.1                                          */
/* HTTP_ACCEPT= *.*; q=0.300, application/octet-stream; q=0.100, text */
/* HTTP_USER_AGENT=IBM-WebExplorer-DLL/v1.1f                          */
/*     Other HTTP_* variables will be set as sent from the browser.   */
/* HTTP=HTTP/1.0                                                      */
/* LOCALHOST=wtscpok.itso.ibm.com                                     */
/* LOCALPORT=83                                                       */
/* LOGPIPE=>> httpd logfile a                                         */
/* OPS_ENV=CMS                                                        */
/* PATH_TRANSLATED=TEST *CGI *                                        */
/* PATH=/htbin/test                                                   */
/* PORT=83                                                            */
/* POST.0=TEST                                                        */
/* POST.TEST=yes                                                      */
/* QUERY_STRING=test=yes                                              */
/* REQUEST_METHOD=GET                                                 */
/* SCRIPT_NAME=/htbin/test                                            */
/* SERVER_NAME=wtscpok.itso.ibm.com                                   */
/* SERVER_PORT=83                                                     */
/* SERVER_PROTOCOL=HTTP/1.0                                           */
/* SERVER_SOFTWARE_LIST=Webshare/1.2.3 VM_ESA/2.2.9507 CMS/11.507 REX */
/* SERVER_SOFTWARE=Webshare/1.2.3                                     */
/* SERVER_URL=SERVER_URL                                              */
/* SOCKET=2                                                           */
/* THREADSELECT=                                                      */
/* USERWEBS=ON                                                        */
/* VERB=GET                                                           */
/* VERBOSE=VERBOSE                                                    */
/* VERSION=VM/CMS Webshare 2.4                                        */
/* VM_WEBSERVER=0                                                     */
/* VRM=1.2.4                                                          */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*--------------------------------------------------------------------*/
/*                                                                    */
/* The following variables are available for                          */
/* EnterpriseWeb                                                      */
/*                                                                    */
/* path: /htbin/test?test=yes                                         */
/*                                                                    */
/* the following variables are set in this universal cgi:             */
/* ( the '.' in HTTP_ACCEPT=*.*; should be translated to '/',         */
/*   but is treated as 'end of comment' here)                         */
/*                                                                    */
/* ACCESSINT=60                                                       */
/* ACCESSMODES=*                                                      */
/* ARG=test=yes                                                       */
/* ARGS=test=yes                                                      */
/* AUTOGROUP=OFF                                                      */
/* AUTOINDEX=ON                                                       */
/* CLIENT=9.12.14.94                                                  */
/* CONFIG_FILE=STEVE CONFIG *                                         */
/* CONTENT_LENGTH=0                                                   */
/* COOKIES=0                                                          */
/* DEFAULT_REALM=EnterpriseWeb                                        */
/* DEFAULTBLOCK=61440                                                 */
/* DEFAULTMEDIA=Text/Plain 8BIT - - -                                 */
/* ENTRYFILTER=OFF                                                    */
/* EWEB.THREAD=2                                                      */
/* FASTDISKS=*                                                        */
/* FASTMODE=OFF                                                       */
/* FASTOVERRIDE=ON                                                    */
/* FASTPATH=/VM/                                                      */
/* FASTPUBDISKS=*                                                     */
/* FILE=/htbin/test.cgi                                               */
/* FILEPOOL=SFSLSY4:                                                  */
/* FQDN=OFF                                                           */
/* GATEWAY_INTERFACE=CGI/1.1                                          */
/* GMTOFFSET=-5.00                                                    */
/* HEADER_DIGESTION=ON                                                */
/* HEADERS=1                                                          */
/* HOSTADDR=9.12.14.94                                                */
/* HTTP_ACCEPT= *.*; q=0.300, application/octet-stream; q=0.100, text */
/* HTTP_USER_AGENT=IBM-WebExplorer-DLL/v1.1f                          */
/*     Other HTTP_* variables will be set as sent from the browser.   */
/* HTTP=HTTP/1.0                                                      */
/* HTTPS=OFF                                                          */
/* IDENT=NOIDENT                                                      */
/* IF_MODIFIED_SINCE=ON                                               */
/* IPFILTER=OFF                                                       */
/* LAST_MODIFIED=ON                                                   */
/* LISTF_ALLFILE=ALLFILE ALLOC                                        */
/* LOCALHOST=wtscpok.itso.ibm.com                                     */
/* LOCALPORT=90                                                       */
/* LOGFORMAT=STANDARD                                                 */
/* LOGLINE=@STD 9.12.14.94 - - [12/Nov/1996:14:30:04 -5.00] "GET /bon */
/* LOGPIPE=CONSOLE                                                    */
/* MOZILLA_SUPPORT=ON                                                 */
/* OPS_ENV=CMS                                                        */
/* PATH_TRANSLATED=TEST CGI J                                         */
/* PATH=/htbin/test.cgi                                               */
/* PORT=90                                                            */
/* POST.0=TEST                                                        */
/* POST.TEST=yes                                                      */
/* QUERY_STRING=test=yes                                              */
/* REMOTE_ADDR=9.12.14.94                                             */
/* REQUEST_METHOD=GET                                                 */
/* REQUEST=GET /htbin/test.cgi?test=yes HTTP/1.0                      */
/* RESPECT_FM=J                                                       */
/* REVERSEDNS=OFF                                                     */
/* ROOT=SFSLSY4:VETTER.R96LS2505                                      */
/* ROOTTYPE=SFS                                                       */
/* SCRIPT_NAME=/htbin/test.cgi                                        */
/* SERVER_COOKIES=ON                                                  */
/* SERVER_HEADERS=ON                                                  */
/* SERVER_MODES=ABCDEFGHISXYZ                                         */
/* SERVER_NAME=wtscpok.itso.ibm.com                                   */
/* SERVER_PORT=90                                                     */
/* SERVER_PROTOCOL=HTTP/1.0                                           */
/* SERVER_SOFTWARE_LIST=EnterpriseWeb/1.1.1 VM_ESA/2.2.9507 CMS/11.50 */
/* SERVER_SOFTWARE=EnterpriseWeb/1.1.1                                */
/* SERVER_URL=http://wtscpok.itso.ibm.com:90/                         */
/* SFSPATH=SFSLSY4:VETTER.R96LS2505.BONUSPAK2.CGIBIN                  */
/* SIGL=155                                                           */
/* SOCKET=2                                                           */
/* SSI=ON                                                             */
/* SSIDISKS=*                                                         */
/* THREAD=2                                                           */
/* THREADING=OFF                                                      */
/* THREADSELECT=SELECT THREAD2                                        */
/* USERWEB_FM=J                                                       */
/* USERWEBLINKP=CHALLENGE                                             */
/* USERWEBS=ON                                                        */
/* USERWEBSPECIFY=ON                                                  */
/* VERB=GET                                                           */
/* VERBOSE=TERSE                                                      */
/* VERSION=EnterpriseWeb 1.1.1 VM/CMS                                 */
/* VM_WEBSERVER=0                                                     */
/* VRM=1.1.1                                                          */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*--------------------------------------------------------------------*/
/*                                                                    */
/* The following variables are available for                          */
/* VM:Webgateway (Webshare compatibility mode)                        */
/*                                                                    */
/* path: /htbin/test?test=yes                                         */
/*                                                                    */
/* the following variables are set in this universal cgi:             */
/* ( the '.' in HTTP_ACCEPT=*.*; should be translated to '/',         */
/*   but is treated as 'end of comment' here)                         */
/*                                                                    */
/* ARGS=test=yes                                                      */
/* CGIUSERS=                                                          */
/* CONTENT_LENGTH=0                                                   */
/* FILE=/HTBIN/test.cgi                                               */
/* GATEWAY_INTERFACE=CGI/1.1                                          */
/* HOSTADDR=9.12.14.94                                                */
/* HTTP_ACCEPT=*.*; q=0.300,application/octet-stream; q=0.100,text/pl */
/* HTTP_USER_AGENT=IBM-WebExplorer-DLL/v1.1f                          */
/*     Other HTTP_* variables will be set as sent from the browser.   */
/* HTTP=HTTP/1.0                                                      */
/* LOCALHOST=WTSCPOK.ITSO.IBM.COM                                     */
/* LOCALPORT=81                                                       */
/* LOGPIPE=CONSOLE                                                    */
/* OPS_ENV=CMS                                                        */
/* PATH_USER=                                                         */
/* PATH=/HTBIN/test.cgi                                               */
/* PORT=81                                                            */
/* POST.0=TEST                                                        */
/* POST.TEST=yes                                                      */
/* QUERY_STRING=test=yes                                              */
/* REMOTE_ADDR=9.12.14.94                                             */
/* REQUEST_METHOD=GET                                                 */
/* SCRIPT_NAME=/HTBIN/test.cgi                                        */
/* SERVER_NAME=WTSCPOK.ITSO.IBM.COM                                   */
/* SERVER_PORT=81                                                     */
/* SERVER_PROTOCOL=HTTP/1.0                                           */
/* SERVER_SOFTWARE=VM:Webserver/2.2                                   */
/* THREADSELECT=                                                      */
/* USER=                                                              */
/* USERWEBS=ON                                                        */
/* VERB=GET                                                           */
/* VERBOSE=TERSE                                                      */
/* VERSION=VM/CMS VM:Webserver 2.2                                    */
/* VM_WEBSERVER=1                                                     */
/* VRM=2.2                                                            */
/* X_PATH_TRANSLATED_OUTCOME=NO_PATH_INFO                             */
/* X_SCRIPT_NAME_TRANSLATED=TEST CGI SFS SFSLSY4:VETTER.R96LS2505.BON */
/* X_SERVER_SCHEME=http                                               */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*--------------------------------------------------------------------*/
/*                                                                    */
/* The following variables are available for                          */
/* VM:Webgateway (not Webshare compatibility mode)                    */
/*                                                                    */
/* path: /htbin/test?test=yes                                         */
/*                                                                    */
/* the following variables are set in this universal cgi:             */
/* ( the '.' in HTTP_ACCEPT=*.*; should be translated to '/',         */
/*   but is treated as 'end of comment' here)                         */
/*                                                                    */
/* AUTH_TYPE=                                                         */
/* CONTENT_LENGTH=                                                    */
/* CONTENT_TYPE=                                                      */
/* GATEWAY_INTERFACE=CGI/1.1                                          */
/* HTTP_ACCEPT=*.*; q=0.300,application/octet-stream; q=0.100,text/pl */
/* HTTP_USER_AGENT=IBM-WebExplorer-DLL/v1.1f                          */
/*     Other HTTP_* variables will be set as sent from the browser.   */
/* OPS_ENV=CMS                                                        */
/* PATH_INFO=                                                         */
/* PATH_TRANSLATED=                                                   */
/* POST.0=TEST                                                        */
/* POST.TEST=yes                                                      */
/* QUERY_STRING=test=yes                                              */
/* REMOTE_ADDR=9.12.14.94                                             */
/* REMOTE_HOST=                                                       */
/* REMOTE_IDENT=                                                      */
/* REMOTE_USER=                                                       */
/* REQUEST_METHOD=GET                                                 */
/* SCRIPT_NAME=/HTBIN/TEST.CGIEXEC                                    */
/* SERVER_NAME=WTSCPOK.ITSO.IBM.COM                                   */
/* SERVER_PORT=81                                                     */
/* SERVER_PROTOCOL=HTTP/1.0                                           */
/* SERVER_SOFTWARE=VM:Webserver/2.2                                   */
/* VM_WEBSERVER=1                                                     */
/* X_AUTH_PRIVATE_INFO=                                               */
/* X_AUTH_VERIFIED=0                                                  */
/* X_PATH_TRANSLATED_OUTCOME=NO_PATH_INFO                             */
/* X_SCRIPT_NAME_TRANSLATED=TEST CGIEXEC SFS SFSLSY4:VETTER.R96LS2505 */
/* X_SERVER_SCHEME=http                                               */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*--------------------------------------------------------------------*/
 
/* Overview
  When a CGI REXX script is executing, anything written out to the
  standard out will be sent to the browser as part of the HTML page
  AFTER the beginning HTML header is generated.  This makes it very
  easy to generate any type of page.*/
 
/*--------------------------------------------------------------------*/
/*                                                                    */
/* To write a CGI you only need to call the following sequence:       */
/*                                                                    */
/* call Init                                                          */
/* call Read                                                          */
/*                                                                    */
/* Thereafter, the variable stem post. contains all data posted to    */
/* the request (for example all data posted from a form).             */
/*                                                                    */
/* For any line you wish to return to the client just call:           */
/*                                                                    */
/* call write 'STRING' 'whatever you like'                            */
/* call write 'STRING' 'It is now' time()                             */
/*                                                                    */
/* It is also possible to write a single variable or a complete       */
/* variable stem:                                                     */
/*                                                                    */
/* call write 'VAR varname'                                           */
/* or                                                                 */
/* call write 'STEM stemname.'                                        */
/*                                                                    */
/*--------------------------------------------------------------------*/
 
trace o
 
parse arg arg
 
call init                  /* Initialize variable environment for CGI */
 
call read                 /* Get additional information passed to CGI */
 
/*--------------------------------------------------------------------*/
/*- local processing start -------------------------------------------*/
/*- This is just sample code that shows you all the variables set by -*/
/*- the 'init' and 'read' routines and where they came from.         -*/
/*--------------------------------------------------------------------*/
 
pipe '(end ? name testcgi)',
     'rexxvars',
  '|  buffer',
  '|  var sourcestring',          /* Rexx "parse source" string     */
  '|  drop 1',
  '|  change 1.2 /v /=/',         /* Decode 'rexxvars' format       */
  '|  change 1.2 /n //',
  '|  join',                      /* Bring name and value together  */
  '|  sort',
  '|  change /</&lt;/',           /* Change these so they don't     */
  '|  change />/&gt;/',           /*   confuse the web browser!     */
  '|h:nlocate 1.5 "HTTP_"',       /* All HTTP header variables      */
  '|p:nlocate 1.5 "POST."',       /* Any data POSTed                */
  '|c:lookup fs = f1 w1 details', /* find CGI environment vars      */
  '|z:faninany',                  /* Include HTTP_ variables        */
  '|  stem cgivars.',             /* List of CGI variables & values */
  '|  locate 1.13 "QUERY_STRING="', /* Find the QUERY_STRING var    */
  '|  append literal',
  '|  var qstring',               /* The QUERY_STRING from browser  */
  '?h:',                          /* HTTP_ header variables         */
  '|z:',
  '?p:',                          /* Any data POSTed from client    */
  '|  stem postvars.',
 ,         /* List the CGI standard environment variables           */
  '?  literal AUTH_TYPE CONTENT_LENGTH CONTENT_TYPE GATEWAY_INTERFACE',
             'PATH_INFO PATH_TRANSLATED QUERY_STRING REMOTE_ADDR',
             'REMOTE_HOST REMOTE_IDENT REMOTE_USER REQUEST_METHOD',
             'SCRIPT_NAME SERVER_NAME SERVER_PORT SERVER_PROTOCOL',
             'SERVER_SOFTWARE',
  '|  split',
  '|c:',
  '|l:lookup fs = f1 w1 details', /* find local environment vars    */
  '|  stem localvars.',           /* List of local vars and values  */
 ,         /* List the variables set by this exec                   */
  '?  literal $HEADER_WRITTEN $SERVER ARG OPS_ENV PIPE PIPE_OUTPUT',
             'RC SIGL VM_WEBSERVER',
  '|  split',
  '|l:',
  '|x:nlocate 1.7 "X_HTTP_"',     /* Header vars set by this program*/
  '|  stem envvars.',             /* Other environment variables    */
  '?x:',
  '|  stem xtraheaders.'
 
/* Write standard CGI server directives */
If RC=0 then do
   Call header 'STR Status: 200 OK'           /* response status    */
   Call header 'STR Content-type: text/html'  /* The data type sent */
end
else do
   error = '500 Internal error RC=' RC
   call header 'STR Status:' error
   call header 'STR Content-type: text/plain'    /* Just plain text */
   call write  'VAR error'           /* Put the error msg on screen */
   exit
end
 
/*- Create an HTML document to display on the browser ----------------*/
call write 'STR <HTML>'
/*- Un comment the following line to test an ISINDEX tag -------------*/
/* call write 'STR <HEAD><ISINDEX></HEAD>' */
call write 'STR <BODY><B>The QUERY_STRING:</B><PRE>'
call write 'VAR qstring'
call write 'STR </PRE><HR><B>Any POST or decoded QUERY_STRING data:</B>'
call write 'STR <BR>(QUERY_STRING is decoded by this CGI only when no',
               'data is POSTed from your browser.)<PRE>'
call write 'STEM postvars.'
call write 'STR </PRE><HR><B>Standard CGI environment variables:</B><PRE>'
call write 'STEM cgivars.'
call write 'STR </PRE><HR><B>Other server environment variables:</B><PRE>'
call write 'STEM envvars.'
If xtraheaders.0 > 0 then do
   call write 'STR </PRE><HR><B>Variables set from request fields:</B><PRE>'
   call write 'STEM xtraheaders.'
end
call write 'STR </PRE><HR><B>Other variables set by the CGI program:</B>'
call write 'STR <PRE>Rexx Source string:' substr(sourcestring,3)
/*- Show how PIPE and PIPE_OUTPUT variables are used: ----------------*/
pipe 'stem localvars. |' pipe_output
call write 'STR </PRE></BODY></HTML>'
 
/*--------------------------------------------------------------------*/
/*- local processing end ---------------------------------------------*/
/*--------------------------------------------------------------------*/
exit
 
/*--------------------------------------------------------------------*/
/*- Initialize variable environment for CGI --------------------------*/
/*--------------------------------------------------------------------*/
/*                                                                    */
/* Init:                                                              */
/*   - First find out where I am (VM/ESA, OS/390 ......)              */
/*   - On VM/ESA find out what Server Software I am running on        */
/*     (Webshare, EnterprisWeb or VM:Webgateway)                      */
/*   - Load variable environment                                      */
/*                                                                    */
/*--------------------------------------------------------------------*/
Init:
$header_written = 0          /* Have any header fields been written?  */
parse source ops_env .
select
  when ops_env = 'CMS' then do                      /* o.k. - it's VM */
    /* If we are a Webshare based CGI, this is how we get CGI vars.   */
    address command 'GLOBALV SELECT HTTPD GET SERVER_SOFTWARE'
    /* If we are VM:Webgateway based, this nucleus extension exists.  */
    address command 'NUCEXT CGI'
    vm_webserver = (rc = 0)
 
    /* Determine what style of CGI we are.                            */
    select
       /* If server_software is set, we are Webshare based CGI.       */
       when left(server_software,13) = 'EnterpriseWeb',   /* Beyond   */
          then $server = 'ENTERPRISEWEB'
       when left(server_software,8)  = 'CMSHTTPD', /* Webshare V1.2.0 */
          | left(server_software,8)  = 'Webshare', /* Webshare V1.2.3 */
          then $server = 'WEBSHARE'
       when left(server_software,12) = 'VM:Webserver',    /* Sterling */
          | left(server_software,13) = 'VM:Webgateway',   /* Sterling */
          then $server = 'VMWEBSERVER_COMPAT'
       /* Not Webshare based, perhaps in VM:Webgateway?               */
       when vm_webserver,                                 /* Sterling */
          then $server = 'VMWEBSERVER'
       /* We do not know where we are running.                        */
       otherwise $server = '?????'
    end
 
    /* Determine how to address commands to PIPEs.                    */
    address command 'SET CMSTYPE HT'
    'callpipe hole'
    pipe_rc = rc
    address command 'SET CMSTYPE RT'
    if pipe_rc = 0
       then pipe = 'callpipe'
       else pipe = 'PIPE'
    drop pipe_rc
 
    select
       when $server = 'ENTERPRISEWEB',
          | $server = 'WEBSHARE',
          | $server = 'VMWEBSERVER_COMPAT',
          then do
 
/*- now get the general server information available anytime ---------*/
 
          'callpipe command GLOBALV SELECT HTTPD LIST',
                 '| drop 1',
                 '| strip leading',
                 '| change //=/',
                 '| nfind =GTYPE.'||,
                 '| nfind =MTYPE.'||,
                 '| nfind =PIPE.'||,
                 '| nfind =TYPE.'||,
                 '| varload'
 
/*- check for additional information ---------------------------------*/
 
          'streamstate input 1'         /* Stream with header records */
          if rc>=0 & rc<12 then
             /* Note: this may incorrectly combine some fields..      */
             'callpipe *.input.1:',       /* They should be variables */
                    '| xlate w1 upper - _',
                    '| spec fs : f1 1 f2-* strip 21',
                    '| sort 1-20',
                    '| join keylength 20 /, /',
                    '| spec /=X_HTTP_/ 1 w1 next /=/ next 21-* next',
                    '| varload'             /* Load as extension vars */
 
          'streamstate input 2'          /* Additional EWEB variables */
          if rc>=0 & rc<12 then
             'callpipe *.input.2: | varload'
 
          if datatype(eweb.thread,'W'),
             then threadselect = "SELECT THREAD" || eweb.thread
             else threadselect = ""                    /* Try default */
 
/*- and load if available --------------------------------------------*/
 
          'callpipe command GLOBALV' threadselect 'LIST',
                 '| drop 1',
                 '| strip leading',
                 '| specs /=/ 1 1-* n',
                 '| nfind =GTYPE.'||,
                 '| nfind =MTYPE.'||,
                 '| nfind =PIPE.'||,
                 '| nfind =TYPE.'||,
                 '| varload'
 
/*- Specify the pipe stage to use for pipelines output ---------------*/
 
          pipe_output = '*.output.0:'
       end
/*--------------------------------------------------------------------*/
       when $server = 'VMWEBSERVER' then do
          /* Sterling in non-compatibility mode */
 
          'CGI GETVAR * (STEM GETVAR.'
 
          address command 'PIPE rexxvars',
                             '| drop 1',
                             '| specs /=/ 1 3-* n',
                             '| join',
                             '| nfind =GETVAR.0'||,
                             '| find =GETVAR.'||,
                             '| specs fs . /=/ 1 f2-* n',
                             '| buffer',
                             '| varload'
 
/*- Specify the pipe stage to use for pipelines output ---------------*/
 
          pipe_output ='join * x0D25 65535',
                     '| change ""CGI WRITE DOCUMENT',
                                '(TRANSLATE USENGLISH CRLF STRING "',
                     '| command'
 
          drop getvar.
 
       end
/*--------------------------------------------------------------------*/
       otherwise do
          say 'Unknown Webserver software ('server_software')'
       end
    end
  end
  otherwise do
     say 'Operating System not supported ('ops_env')'
     $server = '?????'
  end
end
return
 
 
/*--------------------------------------------------------------------*/
/*- Get additional information for CGI -------------------------------*/
/*- This routine will obtain any posted data and place it in the     -*/
/*- stem POST.  POST.0 will contain the name of the variables and    -*/
/*- each POST.<var> will contain the value.  If no data was posted,  -*/
/*- but the QUERY_STRING contains values, they will be decoded into  -*/
/*- the POST. stem in the same way.  (Webshare and EWEB do this      -*/
/*- automatically, the code below will do it for VM:Webserver.)      -*/
/*- Note: This routine does not handle forms with repeated field     -*/
/*-       names or names will invalid Rexx symbol characters in them.-*/
/*- Consult the documentation for your web server for more help.     -*/
/*--------------------------------------------------------------------*/
Read:
select
   when $server = 'ENTERPRISEWEB',
      | $server = 'WEBSHARE',
      | $server = 'VMWEBSERVER_COMPAT' then do
 
      'callpipe (end ?)',
             '*.input.0:',            /* Read input from the form      */
            '|  xlate 1-* 05 40',     /* Convert any tab char to space */
            '|  strip',               /* Ignore any empty ones         */
            '|  locate 1',
            '|  xlate fieldsep = f1 upper', /* Upper case field name   */
            '|f:fanout',
            '|  specs "=POST." 1 1-* next', /* Put it in varload fmt.  */
            '|  varload',
            '?f:',
            '|  chop before string "="',   /* Save just the field name */
            '|  join * " "',               /* Make 1 string of names   */
            '|  append literal',           /* Always set a value       */
            '|  var post.0'
 
   end
   when $server = 'VMWEBSERVER' then do
 
      /* Read the posted document into the variable BLOCK.  */
      /* Perform U.S. English ASCII to EBCDIC translation.  */
      'CGI READ 1 (VAR BLOCK TRANSLATE USENGLISH'
 
      If rc = 12 then do  /* RC=12 means EOF - nothing was read */
         rc=0
         /* If no post data read, but the QUERY_STRING is set */
         /*   then decode it (like Webshare would do..)       */
         if symbol('QUERY_STRING') = 'VAR' then
            block=query_string
         else
            block=''
      end
 
      /* If any information was read, assume it is actually   */
      /*   form encoded data (as Webshare based products do), */
      /*   and break it down into the stem variable POST.     */
      /* "SYMCHARS $." tells it to allow all valid Rexx       */
      /*   symbol chars in the stem.  See the help for CGI    */
      /*   URLDECODE for more information.                    */
      if Length(block) <> 0 then
         'CGI URLDECODE (VAR BLOCK MODE TRANSFORMED' ,
                         'INTO POST. SYMCHARS $.',
                         'TRANSLATE USENGLISH'
      else
         post.0=''
 
      drop block
 
   end
   otherwise
end
return
 
 
/*--------------------------------------------------------------------*/
/*- Write CGI server directives (HTTP response fields) ---------------*/
/*--------------------------------------------------------------------*/
Header:
 
parse arg ctl text
ctl = translate(ctl)
select
   when $server = 'ENTERPRISEWEB',
      | $server = 'WEBSHARE',
      | $server = 'VMWEBSERVER_COMPAT' then do
 
      /* Headers are written to the primary output stream before  */
      /* any data is written.                                     */
      /* The "Status" field is not an HTTP header, but a server   */
      /* directive that must be changed into the real HTTP        */
      /* response record for "Webshare" I/O interface web servers.*/
      If $header_written = 0 then    /* First field not written?  */
         select
            when abbrev('VAR',ctl,1) then do
               Parse value value(text) with ?first ?rest
               If ?first = 'Status:' then
                  call value text,'HTTP/1.0' ?rest
            end
            when abbrev('STEM',ctl,3) then do
               Parse value value(text||'1') with ?first ?rest
               If ?first = 'Status:' then
                  call value text||'1','HTTP/1.0' ?rest
            end
            when abbrev('STRING',ctl,3) then do
               Parse var text ?first ?rest
               If ?first = 'Status:' then
                  text = 'HTTP/1.0' ?rest
            end
            otherwise
         end
      select
         when abbrev('VAR',ctl,1) then
            'output' value(text)
         when abbrev('STEM',ctl,3) then
            'callpipe stem' text'| *.output.0:'
         when abbrev('STRING',ctl,3) then
            'output' text
         otherwise
      end
   end
   when $server = 'VMWEBSERVER' then do
      select
         when abbrev('VAR',ctl,1) then
            'CGI WRITE HEADER (VAR' translate(text)
         when abbrev('STEM',ctl,3) then
            'CGI WRITE HEADER (STEM' translate(text)
         when abbrev('STRING',ctl,3) then
            'CGI WRITE HEADER (STRING' text
         otherwise
      end
   end
   otherwise
end
$header_written = 1     /* We wrote at least 1 header field */
return
 
 
/*--------------------------------------------------------------------*/
/*- Write records to CGI output --------------------------------------*/
/*--------------------------------------------------------------------*/
Write:
 
parse arg ctl text
ctl = translate(ctl)
select
   when $server = 'ENTERPRISEWEB',
      | $server = 'WEBSHARE',
      | $server = 'VMWEBSERVER_COMPAT' then do
 
      /* Was a header written before we wrote any data? */
      if $header_written = 1 then do
         'output'               /* Need a blank line before the data */
         $header_written = 0    /* ..but only write it one time.     */
      end
 
      select
         when abbrev('VAR',ctl,1) then
            'output' value(text)
         when abbrev('STEM',ctl,3) then
            'callpipe stem' text'| *.output.0:'
         when abbrev('STRING',ctl,3) then
            'output' text
         otherwise
      end
   end
   when $server = 'VMWEBSERVER' then do
      /* Note: VM:Webgateway automatically writes the header seperator */
      select
         when abbrev('VAR',ctl,1) then
            'CGI WRITE DOCUMENT (TRANSLATE USENGLISH CRLF VAR',
            translate(text)
         when abbrev('STEM',ctl,3) then
            'CGI WRITE DOCUMENT (TRANSLATE USENGLISH CRLF STEM',
            translate(text)
         when abbrev('STRING',ctl,3) then
            'CGI WRITE DOCUMENT (TRANSLATE USENGLISH CRLF STRING' text
         otherwise
      end
   end
   otherwise
end
return
